function CreateGlossary takes integer countsymbols returns nothing
    local string DefaultGlossary="0WVUYXZRQSTqPONMLponmlKkJjIiHhGgFfEeDdCcBbAa1r2s3t4u5v6w7x8y9z~`!@#$%^&*()-_=+;:[]{},.<>/?"
    local integer i 
    if countsymbols==0 then
        set i=61
    else
        set i=IMinBJ(90,countsymbols)
    endif  
    call StoreStringBJ( SubStringBJ(DefaultGlossary,1,i), "Glossary", "Glossary", udg_pvpcache )
endfunction

function CustomGlossary takes string s returns nothing
    call StoreStringBJ( s, "Glossary", "Glossary", udg_pvpcache )    
endfunction

function GetGlossary takes nothing returns string
    return GetStoredStringBJ("Glossary", "Glossary", udg_pvpcache )    
endfunction

function St takes real i, integer s returns real
    local integer tmp=1
    local real result=i
    if s<=0 then
        return 1
    endif
    if s==1 then
        return i
    endif
    loop
        exitwhen tmp==s
        set result=result*i 
        set tmp=tmp+1       
    endloop
    return result
endfunction

function pos takes string s, string source returns integer
    local integer i=1
    loop
        exitwhen i==StringLength(source)+1
        if (SubStringBJ(source,i,i)==s) then
            return i
        endif
        set i=i+1
    endloop
    return 0
endfunction

function Integer takes real r returns integer
   local real i=1
   if r<1 then
   return 0
   endif
   loop
      exitwhen r-i<1
        set i=i+1
    endloop
    return R2I(i)
endfunction

function GetCodeLengthLongint takes integer i returns integer
    local integer j=2
    local integer tmp=StringLength(GetGlossary())
    loop
        exitwhen i<=tmp
        set tmp=tmp*(StringLength(GetGlossary()))
        set j=j+1
    endloop
    set j=j-1
    return j   
endfunction

function GetCodeLength takes integer i returns integer
    local integer j=2
    local integer tmp=StringLength(GetGlossary())-1
    if (i>59049) and (ModuloInteger(i,10)!=0) then
    return GetCodeLengthLongint(i)
    endif
    loop
        exitwhen i<=tmp
        set tmp=tmp*(StringLength(GetGlossary())-1)
        set j=j+1
    endloop
    set j=j-1
    return j   
endfunction

function GetCharCode takes integer i returns string
    local string source=GetGlossary()
    local string result=""
    local integer l=StringLength(source)-1
    local integer tmp
    local integer le=GetCodeLength(i)-1
    if i>=10000000 then
    return "!!!"
    endif
    if i==0 then
        return SubStringBJ(source,1,1)
    endif
    if (i<=l) then
        set result=result+SubStringBJ(source,i+1,i+1)
    else
        
        loop
            exitwhen le==-1
            set tmp=Integer(i/St(I2R(l+1),le))
            if (i==0) or (tmp==0) then
                set result=result+SubStringBJ(source,1,1)
            else    
            if i<=l then
                set result=result+SubStringBJ(source,i+1,i+1)
            else
                set tmp=Integer(i/St(I2R(l+1),le))
                set result=result+SubStringBJ(source,tmp+1,tmp+1)
                set i=R2I(ModuloReal(I2R(i),St(l+1,le)))
            endif
            endif
            set le=le-1  
        endloop   
    endif
return result
endfunction

function GetCharCodeWithLength takes integer i, integer length returns string
    local integer l=GetCodeLength(i)
    local string result=""
    if (GetCodeLength(i)==length) then
        return GetCharCode(i)
    endif
    loop
        exitwhen l==length
        set result=result+SubStringBJ(GetGlossary(),1,1)
        set l=l+1
    endloop
    set result=result+GetCharCode(i)
    return result
endfunction

function Decode takes string s returns integer
    local string source =GetGlossary()
    local integer l=StringLength(s)
    local integer i=1
    local integer m=StringLength(source)
    local integer result=0
    local string char
    if l==0 then
        return 0
    endif
    if l==1 then
        return pos(s,source)-1
    endif
    loop
        exitwhen l==1
        set char=SubStringBJ(s,i,i)
        set result=result+( Decode(char)*R2I( St(I2R(m),l-1)) )
        set l=l-1
        set i=i+1
    endloop
    set char=SubStringBJ(s,StringLength(s),StringLength(s))
    set result=result+Decode(char)
return result
endfunction

function SetItemNumber takes integer itt, integer n returns nothing
    call StoreIntegerBJ( n, I2S(itt), "Items", udg_pvpcache )
    call StoreIntegerBJ( itt, I2S(n), "Numbers", udg_pvpcache )
endfunction

function GetItemNumber takes integer itt returns integer
    return GetStoredIntegerBJ(I2S(itt), "Items", udg_pvpcache)
endfunction

function GetItemId takes integer n returns integer
    return GetStoredIntegerBJ(I2S(n), "Numbers", udg_pvpcache )
endfunction